/*jslint nomen: true, indent: 2, maxerr: 3 */
/*global window, rJS, document, jIO, RSVP, domsugar, JSON */
(function (window, rJS, domsugar, jIO) {
  "use strict";
  var DEFAULT_APP_LIST_DOC = "app-list.json";

  function displayAppList(gadget) {
    var app_list = [];
    return gadget.crib_sw_get(DEFAULT_APP_LIST_DOC)
      .push(function (data) {
        return jIO.util.readBlobAsText(data, data.type);
      })
      .push(function (data) {
        var promise_list = [];
        app_list = JSON.parse(data.target.result);
        for (var i = 0; i < app_list.length; i += 1) {
          promise_list.push(RSVP.all([
            gadget.getUrlFor({
              page: "editor",
              url: app_list[i].application_edit_page
            }),
            gadget.getUrlFor({
              page: "save_load",
              zip_download_path: app_list[i].application_url,
              zip_name: app_list[i].application_title + ".zip",
              start_zip_download: true
            })
          ]));
        }
        promise_list.push(gadget.getUrlFor({
          page: "add_application"
        }));
        return RSVP.all(promise_list);
      })
      .push(function (url_list) {
        var app_list_html = [],
          base_url = window.location.origin,
          current_path = window.location.pathname,
          tmp_url;
        for (var i = 0; i < app_list.length; i += 1) {
          // XXX Ugly Hack
          tmp_url = window.location.pathname + "/" + app_list[i].application_url;
          while (tmp_url.indexOf("//") !== -1) {
            tmp_url = tmp_url.replace("//", "/");
          }
          app_list_html.push(domsugar("div", {class: "col-sm-4 col-md-4"}, [
            domsugar("div", {class: "thumbnail"}, [
              domsugar("img"),
              domsugar("div", {class: "caption"}, [
                domsugar("h3", {text: app_list[i].application_title}),
                domsugar("a", {href: url_list[i][1], class:"btn btn-default",
                               role:"button", text:"⏬", title: "Download"}),
                domsugar("a", {href: url_list[i][0], class:"btn btn-default", role:"button", text:"Edit"}),
                domsugar("a", {href: base_url + tmp_url , class:"btn btn-primary", role:"button", text:"GO", target: "_blank"})

              ])
            ])
          ]))
        }
        app_list_html.push(domsugar("div", {class: "col-sm-4 col-md-4"}, [
          domsugar("div", {class: "thumbnail"}, [
            domsugar("img"),
            domsugar("div", {class: "caption"}, [
              domsugar("h3", {text: "➕ Add"}),
              domsugar("a", {
                href: url_list[url_list.length -1 ] ,
                class:"btn btn-primary", role:"button", text:"GO"
              })
            ])
          ])
        ]))
        domsugar(gadget.element.querySelector('div.row'), app_list_html)
      });
  }
  rJS(window)
    /////////////////////////////////////////////////////////////////
    // ready
    /////////////////////////////////////////////////////////////////

    // Assign the element to a variable
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.element = element;
        });
    })
    //////////////////////////////////////////////
    // acquired methods
    //////////////////////////////////////////////
    .declareAcquiredMethod("getUrlFor", "getUrlFor")
    .declareAcquiredMethod("crib_sw_get", "crib_sw_get")
    .declareAcquiredMethod("crib_sw_put", "crib_sw_put")
    .declareMethod('render', function (options) {
       return displayAppList(this);
    });

}(window, rJS, domsugar, jIO));