/*jslint nomen: true, indent: 2, maxerr: 3 */
/*global window, rJS, Handlebars, document, loopEventListener, RSVP,
   encodeURIComponent */
(function (window, rJS, document, RSVP) {
  "use strict";

  function makeid(length) {
    var result           = '';
    var characters       = 'abcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
      result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
  }

  rJS(window)
    /////////////////////////////////////////////////////////////////
    // ready
    /////////////////////////////////////////////////////////////////

    // Assign the element to a variable
    .ready(function (g) {
      g.props = {};
      return g.getElement()
        .push(function (element) {
          g.props.element = element;
          g.props.start_deferred = RSVP.defer();
        });
    })
    //////////////////////////////////////////////
    // acquired methods
    //////////////////////////////////////////////
    .declareAcquiredMethod("getUrlFor", "getUrlFor")
    .allowPublicAcquisition("getUrlFor", function (argument_list) {
      return this.getUrlFor(argument_list[0]);
    })
    .declareAcquiredMethod("crib_sw_get", "crib_sw_get")
    .allowPublicAcquisition("crib_sw_get", function (argument_list) {
      return this.crib_sw_get(argument_list[0]);
    })
    .declareAcquiredMethod("crib_sw_put", "crib_sw_put")
    .allowPublicAcquisition("crib_sw_put", function (argument_list) {
      return this.crib_sw_put(argument_list[0], argument_list[1]);
    })
    .declareMethod('render', function (options) {
      var gadget = this,
        page_list = ["url_list", "editor", "save_load", "mass_remove"],
        promise_list = [],
        getURL = window.location,
        site = getURL.protocol + "//" + getURL.host,
        edit_base = "https://" + makeid(10) + ".cribjs.nexedi.net/",
        edit_url = edit_base + "#redirect_url=" +
          encodeURIComponent(edit_base + "#page=editor&url=" +
            "index.html" + "&crib_enable_url=" + site + "/crib-enable.html");
      gadget.props.element.querySelector("a.edit-url").href = edit_url;
      page_list.forEach(function (page) {
        promise_list.push(gadget.getUrlFor({page: page}));
      });
      // Handle main title
      return new RSVP.Queue()
        .push(function () {
          return RSVP.all(promise_list);
        })
        .push(function (link_list) {
          for (var i = 0; i < link_list.length; i++) {
            gadget.props.element.querySelector("." + page_list[i]).href = link_list[i];
          }
          return RSVP.all([
            gadget.getDeclaredGadget("app_list"),
            gadget.getDeclaredGadget("zip_loader")
          ]);
        })
        .push(function (gadget_list) {
          return RSVP.all([
            gadget_list[0].render(),
            gadget_list[1].render()
          ]);
        })
        .push(function () {
          return gadget.props.start_deferred.resolve();
        });
    });



}(window, rJS, document, RSVP));